seo:
  title: 'GitLab and Tabnine: AI-powered code completion for GitLab repositories'
  description: >-
    Development teams can get a custom AI model based on their private code that
    enables knowledge sharing, reduced technical debt, and more.
  ogTitle: 'GitLab and Tabnine: AI-powered code completion for GitLab repositories'
  ogDescription: >-
    Development teams can get a custom AI model based on their private code that
    enables knowledge sharing, reduced technical debt, and more.
  noIndex: false
  ogImage: images/blog/hero-images/blog_2757.png
  ogUrl: https://about.gitlab.com/blog/bringing-ai-gitlab-repository
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: https://about.gitlab.com/blog/bringing-ai-gitlab-repository
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "GitLab and Tabnine: AI-powered code completion for GitLab repositories",
            "author": [{"@type":"Person","name":"Brandon Jung"}],
            "datePublished": "2022-03-02",
          }

content:
  title: 'GitLab and Tabnine: AI-powered code completion for GitLab repositories'
  description: >-
    Development teams can get a custom AI model based on their private code that
    enables knowledge sharing, reduced technical debt, and more.
  authors:
    - Brandon Jung
  heroImage: images/blog/hero-images/blog_2757.png
  date: '2022-03-02'
  body: >+


    As AI continues to become more ubiquitous throughout [every aspect of our
    lives](https://www.tabnine.com/blog/is-ai-pair-programming-really-going-to-help-me/),
    it should come as little surprise that programming has picked it up as a
    tool to help make developers more productive. Tabnine is integrating with
    GitLab to bring Tabnine's AI-powered code completion technology to GitLab
    repositories to improve the accuracy and speed of code development.


    We believe that increased development velocity improves the developer’s
    working experience, accelerates feature release cadence, and enables teams
    to respond faster to market opportunities. Users can now get a custom AI
    model based on their private code that enables: 


    - Knowledge sharing

    - Reduced technical debt

    - Faster code reviews

    - Faster onboarding and time to value


    The value of a custom model is about helping a specific team with a specific
    mission be more productive. A team comes in many forms from the most simple
    [two pizza box
    team](https://docs.aws.amazon.com/whitepapers/latest/introduction-devops-aws/two-pizza-teams.html)
    to a large software company with hundreds of internal developers as well as
    thousands of external developers who contribute to a large shared [open
    source code base](/community/contribute/). What all these teams have in
    common is that they have a shared interest in a common code base. This code
    base for any digital company is one of the most important strategic assets
    and anything that helps them build it faster and more consistently requires
    serious consideration.


    GitLab has a robust platform for hosting code for private teams, so it is
    natural that we wanted to make it easier for teams to bring their
    development models together. Developers can now automate the creation of a
    custom model based on their private code. The process is outlined below and
    is seamless for the user as Tabnine will build, validate, and upload the
    private model for the whole team. New developers can now be added to the
    team and will immediately receive custom suggestions based on the codified
    best practices of the team. 


    This is the first of ongoing work that Tabnine is doing to support
    developers together with GitLab and we look forward to getting your feedback
    on how we can make it better for you individually and for your team.


    Here's how to get started: 


    1. As a Tabnine for Teams user, login to [AI Code Completions for Developers
    & Teams](https://app.tabnine.com/profile/) 

    2. Navigate to the “Team AI” tab

    3. Connect to your GitLab repositories

    4. Tabnine will build, test, and upload your private team model

    5. Enjoy your personalized Tabnine AI assistant


    ![Getting
    started](https://about.gitlab.com/images/blogimages/tabnine1.png){: .shadow}


    The GitLab partnership represents Tabnine's latest step towards the goal of
    an end-to-end development platform supporting all developers regardless of
    working environments, coding languages, or IDEs. [Share your feedback with
    Tabnine](https://forms.gle/vCHK5QRoyR5xt6Jg8) on our AI-powered code
    completion technology.

  category: Engineering
  tags:
    - DevOps
    - news
    - code review
config:
  slug: bringing-ai-gitlab-repository
  featured: false
  template: BlogPost
